const puppeteer = require('puppeteer');

async function htmlToImage(htmlContent, outputPath, selector) {
    const browser = await puppeteer.launch();
    const page = await browser.newPage();
    await page.setContent(htmlContent, {waitUntil: 'networkidle0'});

    // Ensure the element exists and is visible
    const element = await page.$(selector);
    if (element) {
        // Take a screenshot of the element
        await element.screenshot({path: outputPath});
        console.log(`Image saved to ${outputPath}`);
    } else {
        console.log('Error: Element not found or not visible.');
    }

    await browser.close();
}

// Assuming process.argv[2] is your HTML content, and process.argv[3] is the output path, process.argv[4] is the selector
const [,, htmlContent, outputPath, selector] = process.argv;

htmlToImage(htmlContent, outputPath, selector).then(() => console.log(`Screenshot of ${selector} completed.`));
